"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.materializeS3 = void 0;

var _utils = require("../utils");

var _filters = require("../filters");

const materializeS3 = rule => s => s // eslint-disable-line import/prefer-default-export
.filter(_filters.outSkip).filter(onEventType(rule)).tap(_utils.printStartPipeline).filter(onContent(rule)).through((0, _utils.splitObject)(rule)).map(toGetRequest(rule)).through((0, _utils.getObjectFromS3)(rule)).map(toPutRequest(rule)).through((0, _utils.putObjectToS3)(rule)).map(toDeleteRequest(rule)).through((0, _utils.deleteObjectFromS3)(rule)).tap(_utils.printEndPipeline);

exports.materializeS3 = materializeS3;

const onEventType = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnEventType)(rule, uow));

const onContent = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnContent)(rule, uow));

const toGetRequest = rule => (0, _utils.faulty)(uow => ({ ...uow,
  getRequest: rule.toGetRequest ?
  /* istanbul ignore next */
  rule.toGetRequest(uow, rule) : undefined
}));

const toPutRequest = rule => (0, _utils.faulty)(uow => ({ ...uow,
  putRequest: rule.toPutRequest ?
  /* istanbul ignore next */
  rule.toPutRequest(uow, rule) : undefined
}));

const toDeleteRequest = rule => (0, _utils.faulty)(uow => ({ ...uow,
  deleteRequest: rule.toDeleteRequest ?
  /* istanbul ignore next */
  rule.toDeleteRequest(uow, rule) : undefined
}));