"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.claimcheck = void 0;

var _highland = _interopRequireDefault(require("highland"));

var _compression = require("./compression");

var _faults = require("./faults");

var _s = require("./s3");

// claim-check pattern support
// https://www.enterpriseintegrationpatterns.com/patterns/messaging/StoreInLibrary.html
const claimcheck = (opt = {}) => s => s // eslint-disable-line import/prefer-default-export
.map((0, _faults.faulty)(uow => ({ ...uow,
  getClaimCheckRequest: uow.event.s3 ? {
    Bucket: uow.event.s3.bucket,
    Key: uow.event.s3.key
  } : undefined
}))).through((0, _s.getObjectFromS3)({
  getRequestField: 'getClaimCheckRequest',
  getResponseField: 'getClaimCheckResponse'
})).map((0, _faults.faulty)(uow => clear({ ...uow,
  event: uow.getClaimCheckResponse ? JSON.parse(Buffer.from(uow.getClaimCheckResponse.Body), _compression.decompress) : uow.event
})));

exports.claimcheck = claimcheck;

const clear = uow => {
  if (uow.getClaimCheckRequest === undefined) {
    // backwards compatibility for test cases
    delete uow.getClaimCheckRequest;
    delete uow.getClaimCheckResponse;
  }

  return uow;
};