"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.decompress = exports.compress = exports.unzip = exports.zip = exports.COMPRESSION_PREFIX = void 0;

var _zlib = _interopRequireDefault(require("zlib"));

var _objectSizeof = _interopRequireDefault(require("object-sizeof"));

const COMPRESSION_PREFIX = 'COMPRESSED';
exports.COMPRESSION_PREFIX = COMPRESSION_PREFIX;

const zip = str => _zlib.default.gzipSync(Buffer.from(str)).toString('base64');

exports.zip = zip;

const unzip = str => _zlib.default.gunzipSync(Buffer.from(str, 'base64')).toString(); // JSON.stringify replacer


exports.unzip = unzip;

const compress = (opt = {
  compressionThreshold: 1024 * 10
}) => (key, value) => key
/* no key is the top */
&& (0, _objectSizeof.default)(value) > opt.compressionThreshold ? `${COMPRESSION_PREFIX}${zip(JSON.stringify(value))}` : value; // JSON.parse reviver


exports.compress = compress;

const decompress = (key, value) => typeof value === 'string' && value.startsWith(COMPRESSION_PREFIX) ? JSON.parse(unzip(value.substring(COMPRESSION_PREFIX.length))) : value;

exports.decompress = decompress;